
%global meadversion 1.0.0
%global namedversion 1.0.0.Final-redhat-1
%global meadalpha .Final_redhat_1
%global meadrel .1
%global serial 3
%global namedversionrel redhat-1

# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_with javadoc
%bcond_without mead

%{?scl:%scl_package %{?scl_prefix}jboss-jaxrs-api_2.0_spec}
%{!?scl:%global pkg_name %{name}}

%bcond_with repolib

%global alternativespriority 010100
%global apiname jaxrs
%global apiversion 2.0
%global apiversionu 2_0
%global apigroupid javax.ws.rs
%global apiartifactid jsr311-api

%global origname jboss-%{apiname}-api_%{apiversion}_spec

%define maven_version 1.0.0.Final-redhat-1

Name:           %{?scl_prefix}%{origname}
Version:        %{meadversion}
Release:        %{serial}%{meadalpha}%{meadrel}%{?dist}
Epoch:          0
Summary:        The Java(TM) API for RESTful Web Services (JAX-RS) %{apiversion}
License:        CDDL-1.0 or GPLv2 with exceptions
URL:            http://fisheye.jboss.org/browse/JBossAS/projects/specs/tags/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}
Group:          Development/Java

%if %with mead
Source100: jboss-jaxrs-api_2.0_spec-1.0.0.Final-redhat-1-scm-sources.zip
Source102: jboss-jaxrs-api_2.0_spec-1.0.0.Final-redhat-1.pom
Source103: jboss-jaxrs-api_2.0_spec-1.0.0.Final-redhat-1-sources.jar
Source104: jboss-jaxrs-api_2.0_spec-1.0.0.Final-redhat-1.jar
Source105: jboss-jaxrs-api_2.0_spec-1.0.0.Final-redhat-1-project-sources.tar.gz
%endif

%if %without mead
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/specs/tags/jboss-jaxrs-api_1.1_spec-1.0.0.Final && tar cjf jboss-jaxrs-api_1.1_spec-1.0.0.Final.tar.bz2 jboss-jaxrs-api_1.1_spec-1.0.0.Final
# Exported revision 110833.
#Source0:        jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.tar.bz2
#Source3:        jaxrs-api-1.1.pom
#Patch0:         jboss-%{apiname}-api_%{apiversion}_spec-pom.patch
%endif

# Removed to avoid conflict on RHEL-7
#Requires:       jboss-specs-parent >= 1.0.0-0.1.Beta2
%if %with mead
BuildRequires:  unzip
%else
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-skins
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-surefire-report-plugin
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:  jboss-parent
BuildRequires:  jboss-specs-parent >= 1.0.0-0.1.Beta2
BuildRequires:  jbossweb-servlet-2.5-api
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{origname}-%{version}-%{release}-root

%description
JSR 311: The Java(TM) API for RESTful Web Services (JAX-RS) %{apiversion}.

%if %with javadoc
%package javadoc
Summary:        Javadoc for %{origname}
Group:          Development/Documentation

Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description javadoc
%{summary}.
%endif

%if %without mead
%package manual
Summary:        Documents for %{origname}
Group:          Development/Documentation

Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires:       %{origname}-javadoc = %{epoch}:%{version}-%{release}

%description manual
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif
%endif

%prep
%if %without mead
%setup -q -n jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}
#comment out to avoid rpmdiff flagging
###%%%patch0 -p1 -b .sav0
%endif

%setup -q -n jboss-jaxrs-api_spec -T -b 100

%build
%if %without mead
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp \
        -e \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -DaltDeploymentRepository=remote-repository::default::file://`pwd`/maven2-brew \
        javadoc:javadoc javadoc:jar source:jar deploy site
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
pushd maven2-brew
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar %{buildroot}%{_javadir}/
%if 0
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/
%endif
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar %{buildroot}%{_javadir}/
%else
%{__cp} -p %{_sourcedir}/%{origname}-%{namedversion}.jar %{buildroot}%{_javadir}/%{origname}-%{namedversion}.jar
%if 0
%{__cp} -p %{_sourcedir}/%{origname}-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/%{origname}-%{namedversion}-javadoc.jar
%endif
%{__cp} -p %{_sourcedir}/%{origname}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{origname}-%{namedversion}-sources.jar
%endif
(cd %{buildroot}%{_javadir}/ && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# jar alternatives
/bin/touch %{buildroot}%{_javadir}/%{apiname}_api.jar
/bin/touch %{buildroot}%{_javadir}/%{apiname}_%{apiversionu}_api.jar

# poms
#%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
#%{__cp} -p %{_sourcedir}/%{origname}-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{origname}-jboss-%{apiname}-api_%{apiversion}_spec.pom

%if %with javadoc
# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{origname}-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{origname}-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/%{origname}-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{origname}-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{origname}-%{namedversion}/META-INF
%endif
%{__ln_s} %{origname}-%{namedversion} %{buildroot}%{_javadocdir}/%{origname}

# javadoc alternatives
/bin/touch %{buildroot}%{_javadocdir}/%{apiname}_%{apiversionu}_api
/bin/touch %{buildroot}%{_javadocdir}/%{apiname}_api
%endif

%clean
%{__rm} -rf %{buildroot}

%if %with javadoc
%post javadoc
%{_sbindir}/update-alternatives --install %{_javadocdir}/%{apiname}_api %{apiname}_api_javadoc %{_javadocdir}/%{origname} %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_javadocdir}/%{apiname}_%{apiversionu}_api %{apiname}_%{apiversionu}_api_javadoc %{_javadocdir}/%{origname} %{alternativespriority}

%preun javadoc
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove %{apiname}_api_javadoc %{_javadocdir}/%{origname}
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api_javadoc %{_javadocdir}/%{origname}
fi
%endif

%files
%defattr(0644,root,root,0755)
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar
%if 0
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-javadoc.jar
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec-javadoc.jar
%endif
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar
%{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec-sources.jar
%ghost %{_javadir}/%{apiname}_%{apiversionu}_api.jar
%ghost %{_javadir}/%{apiname}_api.jar

%if %with javadoc
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{origname}-%{namedversion}
%{_javadocdir}/%{origname}
%ghost %{_javadocdir}/%{apiname}_api
%ghost %{_javadocdir}/%{apiname}_%{apiversionu}_api
%endif

%if %without mead
%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{origname}-%{namedversion}
%doc %{_docdir}/%{origname}
%doc %ghost %{_docdir}/%{apiname}_%{apiversionu}_api
%doc %ghost %{_docdir}/%{apiname}_api
%endif

%if %without mead
%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif
%endif

%changelog
* Tue Nov 07 2017 Permaine Cheung <pcheung@redhat.com> - 1.0.0-3.Final_redhat_1.1
- Fix license (JBEAP-13468)

* Mon Oct 16 2017 Permaine Cheung <pcheung@redhat.com> - 1.0.0-2.Final_redhat_1.1
- Fix license (JBEAP-13468)

* Mon Dec 19 2016 Petr Sakar <psakar@redhat.com> - 1.0.1-1.Beta1_redhat_1.1
- upgrade to 1.0.1.Beta1-redhat-1

* Mon Jul 20 2015 Yong Yang <yyang@redhat.com> - 1.0.0-1.Final_redhat_1.1
- Rebuild

* Mon Jul 20 2015 Yong Yang <yyang@redhat.com> - 1.0.0-1.Final_redhat_1.1
- Build for EAP7

